/**
 * Producer.java
 *
 * This is the producer thread for the bounded buffer problem.
 *
 * @author Greg Gagne, Peter Galvin, Avi Silberschatz
 * @version 1.0 - July 15, 1999
 * Copyright 2000 by Greg Gagne, Peter Galvin, Avi Silberschatz
 * Applied Operating Systems Concepts - John Wiley and Sons, Inc.
 */

import java.util.*;
 
class Producer extends Thread
{
   public Producer(MessageQueue m)
   {
      mbox = m;
   }              
   
   public void run()
   {
   Date message;
     
      while (true)
      {
         int sleeptime = (int) (Server.NAP_TIME * Math.random() );
 
         System.out.println("Producer sleeping for " + sleeptime + " seconds");
         
         try { sleep(sleeptime*1000); } 
         catch(InterruptedException e) {}
   
         message = new Date();      

         // produce an item & enter it into the buffer
         System.out.println("Producer produced " + message);
           
         mbox.send(message);
      }
   }
   
   private  MessageQueue mbox;
}
